import numpy as np
from kaldo.grid import Grid
from ase.build import bulk

replica_grid = np.array([[0, 0, 0],
                         [ 0,  0,  1],
                         [ 0,  0,  2],
                         [ 0,  0, -2],
                         [ 0,  0, -1],
                         [ 0,  1,  0],
                         [ 0,  1,  1],
                         [ 0,  1,  2],
                         [ 0,  1, -2],
                         [ 0,  1, -1],
                         [ 0,  2,  0],
                         [ 0,  2,  1],
                         [ 0,  2,  2],
                         [ 0,  2, -2],
                         [ 0,  2, -1],
                         [ 0, -2,  0],
                         [ 0, -2,  1],
                         [ 0, -2,  2],
                         [ 0, -2, -2],
                         [ 0, -2, -1],
                         [ 0, -1,  0],
                         [ 0, -1,  1],
                         [ 0, -1,  2],
                         [ 0, -1, -2],
                         [ 0, -1, -1],
                         [ 1,  0,  0],
                         [ 1,  0,  1],
                         [ 1,  0,  2],
                         [ 1,  0, -2],
                         [ 1,  0, -1],
                         [ 1,  1,  0],
                         [ 1,  1,  1],
                         [ 1,  1,  2],
                         [ 1,  1, -2],
                         [ 1,  1, -1],
                         [ 1,  2,  0],
                         [ 1,  2,  1],
                         [ 1,  2,  2],
                         [ 1,  2, -2],
                         [ 1,  2, -1],
                         [ 1, -2,  0],
                         [ 1, -2,  1],
                         [ 1, -2,  2],
                         [ 1, -2, -2],
                         [ 1, -2, -1],
                         [ 1, -1,  0],
                         [ 1, -1,  1],
                         [ 1, -1,  2],
                         [ 1, -1, -2],
                         [ 1, -1, -1],
                         [ 2,  0,  0],
                         [ 2,  0,  1],
                         [ 2,  0,  2],
                         [ 2,  0, -2],
                         [ 2,  0, -1],
                         [ 2,  1,  0],
                         [ 2,  1,  1],
                         [ 2,  1,  2],
                         [ 2,  1, -2],
                         [ 2,  1, -1],
                         [ 2,  2,  0],
                         [ 2,  2,  1],
                         [ 2,  2,  2],
                         [ 2,  2, -2],
                         [ 2,  2, -1],
                         [ 2, -2,  0],
                         [ 2, -2,  1],
                         [ 2, -2,  2],
                         [ 2, -2, -2],
                         [ 2, -2, -1],
                         [ 2, -1,  0],
                         [ 2, -1,  1],
                         [ 2, -1,  2],
                         [ 2, -1, -2],
                         [ 2, -1, -1],
                         [-2,  0,  0],
                         [-2,  0,  1],
                         [-2,  0,  2],
                         [-2,  0, -2],
                         [-2,  0, -1],
                         [-2,  1,  0],
                         [-2,  1,  1],
                         [-2,  1,  2],
                         [-2,  1, -2],
                         [-2,  1, -1],
                         [-2,  2,  0],
                         [-2,  2,  1],
                         [-2,  2,  2],
                         [-2,  2, -2],
                         [-2,  2, -1],
                         [-2, -2,  0],
                         [-2, -2,  1],
                         [-2, -2,  2],
                         [-2, -2, -2],
                         [-2, -2, -1],
                         [-2, -1,  0],
                         [-2, -1,  1],
                         [-2, -1,  2],
                         [-2, -1, -2],
                         [-2, -1, -1],
                         [-1,  0,  0],
                         [-1,  0,  1],
                         [-1,  0,  2],
                         [-1,  0, -2],
                         [-1,  0, -1],
                         [-1,  1,  0],
                         [-1,  1,  1],
                         [-1,  1,  2],
                         [-1,  1, -2],
                         [-1,  1, -1],
                         [-1,  2,  0],
                         [-1,  2,  1],
                         [-1,  2,  2],
                         [-1,  2, -2],
                         [-1,  2, -1],
                         [-1, -2,  0],
                         [-1, -2,  1],
                         [-1, -2,  2],
                         [-1, -2, -2],
                         [-1, -2, -1],
                         [-1, -1,  0],
                         [-1, -1,  1],
                         [-1, -1,  2],
                         [-1, -1, -2],
                         [-1, -1, -1]])

k_grid = np.array([[-0.4, -0.4, -0.4],
       [-0.4, -0.4, -0.2],
       [-0.4, -0.4,  0. ],
       [-0.4, -0.4,  0.2],
       [-0.4, -0.4,  0.4],
       [-0.4, -0.2, -0.4],
       [-0.4, -0.2, -0.2],
       [-0.4, -0.2,  0. ],
       [-0.4, -0.2,  0.2],
       [-0.4, -0.2,  0.4],
       [-0.4,  0. , -0.4],
       [-0.4,  0. , -0.2],
       [-0.4,  0. ,  0. ],
       [-0.4,  0. ,  0.2],
       [-0.4,  0. ,  0.4],
       [-0.4,  0.2, -0.4],
       [-0.4,  0.2, -0.2],
       [-0.4,  0.2,  0. ],
       [-0.4,  0.2,  0.2],
       [-0.4,  0.2,  0.4],
       [-0.4,  0.4, -0.4],
       [-0.4,  0.4, -0.2],
       [-0.4,  0.4,  0. ],
       [-0.4,  0.4,  0.2],
       [-0.4,  0.4,  0.4],
       [-0.2, -0.4, -0.4],
       [-0.2, -0.4, -0.2],
       [-0.2, -0.4,  0. ],
       [-0.2, -0.4,  0.2],
       [-0.2, -0.4,  0.4],
       [-0.2, -0.2, -0.4],
       [-0.2, -0.2, -0.2],
       [-0.2, -0.2,  0. ],
       [-0.2, -0.2,  0.2],
       [-0.2, -0.2,  0.4],
       [-0.2,  0. , -0.4],
       [-0.2,  0. , -0.2],
       [-0.2,  0. ,  0. ],
       [-0.2,  0. ,  0.2],
       [-0.2,  0. ,  0.4],
       [-0.2,  0.2, -0.4],
       [-0.2,  0.2, -0.2],
       [-0.2,  0.2,  0. ],
       [-0.2,  0.2,  0.2],
       [-0.2,  0.2,  0.4],
       [-0.2,  0.4, -0.4],
       [-0.2,  0.4, -0.2],
       [-0.2,  0.4,  0. ],
       [-0.2,  0.4,  0.2],
       [-0.2,  0.4,  0.4],
       [ 0. , -0.4, -0.4],
       [ 0. , -0.4, -0.2],
       [ 0. , -0.4,  0. ],
       [ 0. , -0.4,  0.2],
       [ 0. , -0.4,  0.4],
       [ 0. , -0.2, -0.4],
       [ 0. , -0.2, -0.2],
       [ 0. , -0.2,  0. ],
       [ 0. , -0.2,  0.2],
       [ 0. , -0.2,  0.4],
       [ 0. ,  0. , -0.4],
       [ 0. ,  0. , -0.2],
       [ 0. ,  0. ,  0. ],
       [ 0. ,  0. ,  0.2],
       [ 0. ,  0. ,  0.4],
       [ 0. ,  0.2, -0.4],
       [ 0. ,  0.2, -0.2],
       [ 0. ,  0.2,  0. ],
       [ 0. ,  0.2,  0.2],
       [ 0. ,  0.2,  0.4],
       [ 0. ,  0.4, -0.4],
       [ 0. ,  0.4, -0.2],
       [ 0. ,  0.4,  0. ],
       [ 0. ,  0.4,  0.2],
       [ 0. ,  0.4,  0.4],
       [ 0.2, -0.4, -0.4],
       [ 0.2, -0.4, -0.2],
       [ 0.2, -0.4,  0. ],
       [ 0.2, -0.4,  0.2],
       [ 0.2, -0.4,  0.4],
       [ 0.2, -0.2, -0.4],
       [ 0.2, -0.2, -0.2],
       [ 0.2, -0.2,  0. ],
       [ 0.2, -0.2,  0.2],
       [ 0.2, -0.2,  0.4],
       [ 0.2,  0. , -0.4],
       [ 0.2,  0. , -0.2],
       [ 0.2,  0. ,  0. ],
       [ 0.2,  0. ,  0.2],
       [ 0.2,  0. ,  0.4],
       [ 0.2,  0.2, -0.4],
       [ 0.2,  0.2, -0.2],
       [ 0.2,  0.2,  0. ],
       [ 0.2,  0.2,  0.2],
       [ 0.2,  0.2,  0.4],
       [ 0.2,  0.4, -0.4],
       [ 0.2,  0.4, -0.2],
       [ 0.2,  0.4,  0. ],
       [ 0.2,  0.4,  0.2],
       [ 0.2,  0.4,  0.4],
       [ 0.4, -0.4, -0.4],
       [ 0.4, -0.4, -0.2],
       [ 0.4, -0.4,  0. ],
       [ 0.4, -0.4,  0.2],
       [ 0.4, -0.4,  0.4],
       [ 0.4, -0.2, -0.4],
       [ 0.4, -0.2, -0.2],
       [ 0.4, -0.2,  0. ],
       [ 0.4, -0.2,  0.2],
       [ 0.4, -0.2,  0.4],
       [ 0.4,  0. , -0.4],
       [ 0.4,  0. , -0.2],
       [ 0.4,  0. ,  0. ],
       [ 0.4,  0. ,  0.2],
       [ 0.4,  0. ,  0.4],
       [ 0.4,  0.2, -0.4],
       [ 0.4,  0.2, -0.2],
       [ 0.4,  0.2,  0. ],
       [ 0.4,  0.2,  0.2],
       [ 0.4,  0.2,  0.4],
       [ 0.4,  0.4, -0.4],
       [ 0.4,  0.4, -0.2],
       [ 0.4,  0.4,  0. ],
       [ 0.4,  0.4,  0.2],
       [ 0.4,  0.4,  0.4]])


def test_r_mesh():
    grid_shape = (5, 5, 5)
    generated_grid = Grid(grid_shape=grid_shape, order='C')
    np.testing.assert_equal(replica_grid, generated_grid.grid(is_wrapping=True))


def test_ase_grid():
    atoms = bulk('Si', 'diamond', a=5.43)
    n_atoms = atoms.positions.shape[0]
    supercell = (5, 5, 5)
    replicated_atoms = atoms.copy() * (supercell[0], 1, 1) * (1, supercell[1], 1) * (1, 1, supercell[2])

    ase_calculated_replica = np.round(replicated_atoms.positions.dot(np.linalg.inv(atoms.cell)), 5) \
                                 .reshape(supercell[0], supercell[1], supercell[2], n_atoms, 3)

    space_grid = Grid(supercell, order='F')
    fd_calculated_replica = (space_grid.grid(is_wrapping=False)[:, np.newaxis, :] + atoms.positions.dot(np.linalg.inv(atoms.cell)) \
        [np.newaxis, :, :]).reshape(supercell[0],supercell[1],supercell[2],n_atoms, 3)
    np.testing.assert_array_almost_equal(ase_calculated_replica, fd_calculated_replica)
